/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/motion/nhfc-genom3/work/templates/ros/client/ros/nhfc/srv/get_desired.srv
 *
 */


#ifndef NHFC_MESSAGE_GET_DESIREDRESPONSE_H
#define NHFC_MESSAGE_GET_DESIREDRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <nhfc/or_pose_estimator_state.h>

namespace nhfc
{
template <class ContainerAllocator>
struct get_desiredResponse_
{
  typedef get_desiredResponse_<ContainerAllocator> Type;

  get_desiredResponse_()
    : genom_success(false)
    , genom_exdetail()
    , desired()  {
    }
  get_desiredResponse_(const ContainerAllocator& _alloc)
    : genom_success(false)
    , genom_exdetail(_alloc)
    , desired(_alloc)  {
    }



   typedef uint8_t _genom_success_type;
  _genom_success_type genom_success;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _genom_exdetail_type;
  _genom_exdetail_type genom_exdetail;

   typedef  ::nhfc::or_pose_estimator_state_<ContainerAllocator>  _desired_type;
  _desired_type desired;




  typedef boost::shared_ptr< ::nhfc::get_desiredResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::nhfc::get_desiredResponse_<ContainerAllocator> const> ConstPtr;

}; // struct get_desiredResponse_

typedef ::nhfc::get_desiredResponse_<std::allocator<void> > get_desiredResponse;

typedef boost::shared_ptr< ::nhfc::get_desiredResponse > get_desiredResponsePtr;
typedef boost::shared_ptr< ::nhfc::get_desiredResponse const> get_desiredResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::nhfc::get_desiredResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::nhfc::get_desiredResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace nhfc

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'nhfc': ['nhfc/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::get_desiredResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::get_desiredResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::get_desiredResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::get_desiredResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::get_desiredResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::get_desiredResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::nhfc::get_desiredResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f1c681b4b5f8e0c38940bf8618313a66";
  }

  static const char* value(const ::nhfc::get_desiredResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf1c681b4b5f8e0c3ULL;
  static const uint64_t static_value2 = 0x8940bf8618313a66ULL;
};

template<class ContainerAllocator>
struct DataType< ::nhfc::get_desiredResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "nhfc/get_desiredResponse";
  }

  static const char* value(const ::nhfc::get_desiredResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::nhfc::get_desiredResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool genom_success\n\
string genom_exdetail\n\
or_pose_estimator_state desired\n\
\n\
\n\
================================================================================\n\
MSG: nhfc/or_pose_estimator_state\n\
# IDL struct ::or_pose_estimator::state\n\
or_time_ts ts\n\
bool intrinsic\n\
or_t3d_pos[] pos\n\
or_t3d_pos_cov[] pos_cov\n\
or_t3d_vel[] vel\n\
or_t3d_vel_cov[] vel_cov\n\
or_t3d_acc[] acc\n\
or_t3d_acc_cov[] acc_cov\n\
\n\
================================================================================\n\
MSG: nhfc/or_time_ts\n\
# IDL struct ::or::time::ts\n\
uint32 sec\n\
uint32 nsec\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_pos\n\
# IDL struct ::or::t3d::pos\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 qw\n\
float64 qx\n\
float64 qy\n\
float64 qz\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_pos_cov\n\
# IDL struct ::or::t3d::pos_cov\n\
float64[28] cov\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_vel\n\
# IDL struct ::or::t3d::vel\n\
float64 vx\n\
float64 vy\n\
float64 vz\n\
float64 wx\n\
float64 wy\n\
float64 wz\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_vel_cov\n\
# IDL struct ::or::t3d::vel_cov\n\
float64[21] cov\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_acc\n\
# IDL struct ::or::t3d::acc\n\
float64 ax\n\
float64 ay\n\
float64 az\n\
\n\
================================================================================\n\
MSG: nhfc/or_t3d_acc_cov\n\
# IDL struct ::or::t3d::acc_cov\n\
float64[6] cov\n\
";
  }

  static const char* value(const ::nhfc::get_desiredResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::nhfc::get_desiredResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.genom_success);
      stream.next(m.genom_exdetail);
      stream.next(m.desired);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct get_desiredResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::nhfc::get_desiredResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::nhfc::get_desiredResponse_<ContainerAllocator>& v)
  {
    s << indent << "genom_success: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.genom_success);
    s << indent << "genom_exdetail: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.genom_exdetail);
    s << indent << "desired: ";
    s << std::endl;
    Printer< ::nhfc::or_pose_estimator_state_<ContainerAllocator> >::stream(s, indent + "  ", v.desired);
  }
};

} // namespace message_operations
} // namespace ros

#endif // NHFC_MESSAGE_GET_DESIREDRESPONSE_H
