/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/motion/nhfc-genom3/work/templates/ros/client/ros/nhfc/msg/nhfc_ids_servo_s_gain_s.msg
 *
 */


#ifndef NHFC_MESSAGE_NHFC_IDS_SERVO_S_GAIN_S_H
#define NHFC_MESSAGE_NHFC_IDS_SERVO_S_GAIN_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace nhfc
{
template <class ContainerAllocator>
struct nhfc_ids_servo_s_gain_s_
{
  typedef nhfc_ids_servo_s_gain_s_<ContainerAllocator> Type;

  nhfc_ids_servo_s_gain_s_()
    : Kpxy(0.0)
    , Kpz(0.0)
    , Kqxy(0.0)
    , Kqz(0.0)
    , Kvxy(0.0)
    , Kvz(0.0)
    , Kwxy(0.0)
    , Kwz(0.0)  {
    }
  nhfc_ids_servo_s_gain_s_(const ContainerAllocator& _alloc)
    : Kpxy(0.0)
    , Kpz(0.0)
    , Kqxy(0.0)
    , Kqz(0.0)
    , Kvxy(0.0)
    , Kvz(0.0)
    , Kwxy(0.0)
    , Kwz(0.0)  {
    }



   typedef double _Kpxy_type;
  _Kpxy_type Kpxy;

   typedef double _Kpz_type;
  _Kpz_type Kpz;

   typedef double _Kqxy_type;
  _Kqxy_type Kqxy;

   typedef double _Kqz_type;
  _Kqz_type Kqz;

   typedef double _Kvxy_type;
  _Kvxy_type Kvxy;

   typedef double _Kvz_type;
  _Kvz_type Kvz;

   typedef double _Kwxy_type;
  _Kwxy_type Kwxy;

   typedef double _Kwz_type;
  _Kwz_type Kwz;




  typedef boost::shared_ptr< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> const> ConstPtr;

}; // struct nhfc_ids_servo_s_gain_s_

typedef ::nhfc::nhfc_ids_servo_s_gain_s_<std::allocator<void> > nhfc_ids_servo_s_gain_s;

typedef boost::shared_ptr< ::nhfc::nhfc_ids_servo_s_gain_s > nhfc_ids_servo_s_gain_sPtr;
typedef boost::shared_ptr< ::nhfc::nhfc_ids_servo_s_gain_s const> nhfc_ids_servo_s_gain_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace nhfc

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'nhfc': ['nhfc/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c1362e650a10b2c11a00fa66f1dbdc01";
  }

  static const char* value(const ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc1362e650a10b2c1ULL;
  static const uint64_t static_value2 = 0x1a00fa66f1dbdc01ULL;
};

template<class ContainerAllocator>
struct DataType< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "nhfc/nhfc_ids_servo_s_gain_s";
  }

  static const char* value(const ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::nhfc::ids::servo_s::gain_s\n\
float64 Kpxy\n\
float64 Kpz\n\
float64 Kqxy\n\
float64 Kqz\n\
float64 Kvxy\n\
float64 Kvz\n\
float64 Kwxy\n\
float64 Kwz\n\
";
  }

  static const char* value(const ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.Kpxy);
      stream.next(m.Kpz);
      stream.next(m.Kqxy);
      stream.next(m.Kqz);
      stream.next(m.Kvxy);
      stream.next(m.Kvz);
      stream.next(m.Kwxy);
      stream.next(m.Kwz);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct nhfc_ids_servo_s_gain_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::nhfc::nhfc_ids_servo_s_gain_s_<ContainerAllocator>& v)
  {
    s << indent << "Kpxy: ";
    Printer<double>::stream(s, indent + "  ", v.Kpxy);
    s << indent << "Kpz: ";
    Printer<double>::stream(s, indent + "  ", v.Kpz);
    s << indent << "Kqxy: ";
    Printer<double>::stream(s, indent + "  ", v.Kqxy);
    s << indent << "Kqz: ";
    Printer<double>::stream(s, indent + "  ", v.Kqz);
    s << indent << "Kvxy: ";
    Printer<double>::stream(s, indent + "  ", v.Kvxy);
    s << indent << "Kvz: ";
    Printer<double>::stream(s, indent + "  ", v.Kvz);
    s << indent << "Kwxy: ";
    Printer<double>::stream(s, indent + "  ", v.Kwxy);
    s << indent << "Kwz: ";
    Printer<double>::stream(s, indent + "  ", v.Kwz);
  }
};

} // namespace message_operations
} // namespace ros

#endif // NHFC_MESSAGE_NHFC_IDS_SERVO_S_GAIN_S_H
